#!/bin/bash
# args 
#  1: Input - Absolute Path of Target Image to Deform
#  2: Input - Absolute Path of Reference Image Space to Deform Into
#  3: Input - Absolute Path of Deformation Field to Deform by
#  4: Input - Absolute Path of Pre-prossing Affine Matrix to Transform by
#  5: Input - Use Nearest Neighbor Interpolation
#  6: Output - Absolute Path for Deformed Image

target=$1
reference=$2
defField=$3
affineMtx=$4
useNN=$5
output=$6

if [ "$useNN" == "true" ]
then
	useNNtag="--use-Nn"
else
	useNNtag=""
fi


WarpImageMultiTransform 3 $target $output $defField $affineMtx $useNNtag -R $reference
